#define _CRT_SECURE_NO_WARNINGS

#ifndef HUI
#pragma GCC optimize("O3")
#endif // !HUI

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <numeric>
#include <random>
#include <ctime>

typedef long long ll;
typedef long double ld;
long long inf = 1'000'000'007;
long long linf = 1'000'000'000'000'000'007LL;

using namespace std;

void solve() {
	int n, a, b;
	cin >> n >> a >> b;
	map <int, vector <int>> by_dec;
	for (int _ = 0; _ < n; _++) {
		int dec, num;
		cin >> dec >> num;
		by_dec[dec].push_back(num);
	}
	// {insert, delete}
	vector <pair<int, int>> alternatives = { {0, 0} };

	for (auto dec : by_dec) {

		auto arr = dec.second;
		sort(arr.begin(), arr.end());

		map <int, int> count_should_ins;
		count_should_ins[0] = 0;

		for (int i = 0;i < arr.size(); i++) {
			int to_ins = min(n + 1, max(0, (arr[i] - 2 * i)) / 2);
			count_should_ins[to_ins]++;
		}

		vector <pair <int, int>> my_alts = { };

		int to_del = 0;
		for (auto i : count_should_ins) {
			to_del += i.second;
			my_alts.push_back({ i.first, arr.size() - to_del });
		}


		map<int, int> best_option;

		for (auto i : alternatives) {
			for (auto j : my_alts) {
				int new_insert = i.first + j.first;
				int new_kill = i.second + j.second;

				if (!best_option.count(new_insert)) {
					best_option[new_insert] = inf;
				}
				best_option[new_insert] = min(new_kill, best_option[new_insert]);
			}
		}

		alternatives.clear();
		int prev_kill = inf;
		for (auto i : best_option) {
			alternatives.push_back({ i.first, min(i.second, prev_kill) });
			prev_kill = min(prev_kill, i.second);
		}
	}
	int ans = inf;
	for (auto i : alternatives) {
		ans = min(ans, max(i.first, i.second));
	}
	cout << ans << endl;
}

int main() {
#ifdef HUI
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(false);
	cout.sync_with_stdio(false);
	srand(time(0));
	cout.precision(10);

	int tt = 1;
	cin >> tt;
	while (tt--)
		solve();
}