﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <cmath>
#include <cstdlib>
#include <numeric>
#include <chrono>
#include <climits>

using namespace std;

typedef long long ll;
typedef long double ld;

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    map<ll, set<ll>> m;
    for (ll i = 0; i < n; i++)
    {
        cin >> a[i];
        m[a[i]].insert(i);
    }
    pair<ll, set<ll>> maxP = (*(m.rbegin()));
    ll maxV = maxP.first;
    while (maxP.second.size() != n) {
        ll prev;
        ll cur;
        auto it = maxP.second.rbegin();
        if (a[0] == maxP.first && a[n - 1] == maxP.first) {
            prev = n;
            while (it != maxP.second.rend())
            {
                cur = *it;
                if (prev - cur != 1) {
                    prev = cur;
                    break;
                }
                prev = cur;
                advance(it, 1);
            }
        }
        else {
            prev = *it;
        }
        if (prev == n) {
            prev = 0;
        }
        ll posToReduce = prev;
        ll prevPosToReduce = prev - 1;
        if (prevPosToReduce == -1) {
            prevPosToReduce = n - 1;
        }

        ll minV = (*m.begin()).first;
        ll reduce = max((maxV - minV) / 2, 1ll);
        ll bigReduce = reduce * 2;
        a[posToReduce] -= bigReduce;
        ll a_prev_val = a[prevPosToReduce];
        a[prevPosToReduce] -= reduce;
        m[maxV].erase(posToReduce);
        m[a[posToReduce]].insert(posToReduce);
        m[maxV].erase(posToReduce);
        m[a_prev_val].erase(prevPosToReduce);
        m[a[prevPosToReduce]].insert(prevPosToReduce);
        if (m[maxV].empty()) {
            m.erase(maxV);
        }
        if (m[a_prev_val].empty()) {
            m.erase(a_prev_val);
        }
        if (a[posToReduce] <= 0 || a[prevPosToReduce] <= 0) {
            cout << 0 << "\n";
            return;
        }

        maxP = (*(m.rbegin()));
        maxV = maxP.first;
    }

    cout << maxV << "\n";
}

void multitest() {
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

void preCalc() {

}

void fastIO() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
#ifdef _DEBUG
    freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
#endif
    fastIO();
#ifdef _DEBUG
    auto start = chrono::system_clock().now();
#endif
    preCalc();
    multitest();
#ifdef _DEBUG
    auto end = chrono::system_clock().now();
    cout << "\n" << (end - start).count() / 1e7 << " seconds\n";
#endif
}
