﻿#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <string>
#include <utility>
#include <unordered_set>
#include <unordered_map>
#include <set>

void dfs(int64_t v, std::vector<int64_t>& ts, std::vector<std::vector<std::pair<int64_t, int64_t>>>& g, std::vector<int64_t>& u) {
    u[v] = 1;
    for (int64_t v2 = 0; v2 < g[v].size(); ++v2) {
        if (u[g[v][v2].second] == 0)
            dfs(g[v][v2].second, ts, g, u);
    }
    ts.push_back(v);
}

int main() {
    int64_t t;
    std::cin >> t;
    for (int64_t x = 0; x < t; ++x) {
        int64_t n, m;
        std::cin >> n >> m;
        std::vector<std::vector<std::pair<int64_t, int64_t>>> g(n);
        std::unordered_map<int64_t, int64_t> ver;
        std::vector<std::unordered_set<int64_t>> mat(n);
        std::vector<std::pair<int64_t, int64_t>> ed;
        for (int64_t i = 0; i < m; ++i) {
            int64_t u, v;
            std::cin >> u >> v;
            --u; --v;
            g[u].push_back({ 0, v });
            mat[u].insert(v);
            if (ver.count(u) == 0) ver[u] = 0;
            if (ver.count(v) == 0) ver[v] = 0;
            ++ver[u];
            --ver[v];
            ed.push_back({ u, v });
        }

        std::vector<std::pair<int64_t, int64_t>> per(n);
        for (int64_t i = 0; i < n; ++i)
            per[i] = { ver[i], i };
        std::sort(per.begin(), per.end());

        for (int64_t i = 0; i < n; ++i)
            for (int64_t j = 0; j < g[i].size(); ++j)
                g[i][j].first = ver[g[i][j].second];
        for (int64_t i = 0; i < n; ++i)
            std::sort(g[i].begin(), g[i].end());

        std::vector<int64_t> u(n, 0);
        std::vector<int64_t> ts;
        for (int64_t i = 0; i < n; ++i)
            if (u[per[i].second] == 0)
                dfs(per[i].second, ts, g, u);
        std::reverse(ts.begin(), ts.end());
        
        int64_t ct = 0;
        std::vector<int64_t> ats(n);
        for (int64_t i = 0; i < n; ++i)
            ats[ts[i]] = i;
        for (int64_t i = 0; i < m; ++i)
            if (ats[ed[i].first] < ats[ed[i].second])
                ++ct;
        int64_t m2 = (m / 2) + (m % 2);
        if (ct >= m2) {
            for (int64_t i = 0; i < ts.size(); ++i)
                std::cout << ts[i] + 1 << ' ';
            std::cout << '\n';
        }
        else
            std::cout << -1 << '\n';
    }
    return 0;
}