#include <iostream>
#include "bits/stdc++.h"

#include <unordered_set>

#define int long long
using namespace std;

map<int, unordered_set<int>> graph;
map<int, bool> used;
int aaa = -1;
int res_sum = 0;

vector<int> dfs(int v) {
    if (used[v]) {
        aaa = v;
        return {};
    }

    used[v] = true;
    vector<int> res;
    for (auto n : graph[v]) {
        for (auto a : dfs(n)) {
            res.push_back(a);
        }
        if (n == aaa) {
            aaa = -1;
        }
    }
    res.push_back(v);
    return res;
}

struct tree {
    int n;
    vector<int> t;

    void init(int n) {
        this->n = n;
        t.resize(n * 4);
    }

    int merge(const int &a, const int &b) {
        return (a + b);
    }

    void build(const vector<int> &a) {
        build(1, 0, (this->n) - 1, a);
    }

    void build(int v, int l, int r, const vector<int> &a) {
        if (l == r) {
            t[v] = a[l];
            return;
        }
        int m = l + (r - l) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m + 1, r, a);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(const int &x, const int &pos) {
        update(1, 0, (this->n) - 1, x, pos);
    }

    void update(int v, int tl, int tr, const int &x, const int &pos) {
        if (tl == tr) {
            t[v] = x;
            return;
        }

        int tm = tl + (tr - tl) / 2;
        if (tl <= pos && pos <= tm) {
            update(v * 2, tl, tm, x, pos);
        } else if (tm < pos && pos <= tr) {
            update(v * 2 + 1, tm + 1, tr, x, pos);
        } else {
            cerr << "Error: " << pos << "is out of bound" << endl;
        }
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int l, int r) {
        return get(1, 0, (this->n) - 1, l, r);
    }

    int get(int v, int tl, int tr, int l, int r) {
        if (tl > tr || r < l) {
            return 0;
        } else if (tl >= l && tr <= r) {
            return t[v];
        }

        int tm = tl + (tr - tl) / 2;
        return get(v * 2, tl, tm, l, min(r, tm)) + get(v * 2 + 1, tm + 1, tr, max(l, tm), r);
    }
};

void solve_j() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> g;
    map<int, unordered_set<int>> gg;
    int u, v;
    for (int _ = 0; _ < m; _++) {
        cin >> u >> v;
        g.push_back({u, v});
        gg[u].insert(v);
    }
    graph = gg;
    used.clear();
    vector<int> res;
    for (int i = 1; i <= n; ++i) {
        if (used[i]) {
            continue;
        }
        for (auto a : dfs(i)) {
            res.push_back(a);
        }
    }
    reverse(res.begin(), res.end());
    map<int, int> ma;
    for (int i = 0; i < n; ++i) {
        ma[res[i]] = i;
    }
    int s = 0;
    for (auto p : g) {
        s += ma[p.first] < ma[p.second];
    }
    if (s * 2 + 1 < m) {
        cout << "-1\n";
        return;
    }
    for (auto a : res) {
        cout << a << ' ';
    }
    cout << '\n';
}

void solve_k() {
    int inf = 1e9+9;
    string alpahbet = "abcdefghijklmnopqrstuvwxyz";
    int n, e;
    cin >> n;
    cin >> e;
    string ss;
    map<char, int> m;
    vector<bool> ex(e, false);
    for (int i = 0; i < e; i++) {
        ss += alpahbet[i];
        m[alpahbet[i]] = 1;
    }
    vector<string> sp(n);
    string s;
    for (int i = 0; i < n; i++) {
        cin>>s;
        sp[i] = s;
        char st_ch = s[0];
        bool flag = true;
        int j = 0;
        for (; j < sp[i].size(); j++) {
            if(st_ch != s[j]){
                flag = false;
                break;
            }
        }
        if(flag){
            //Тогда вся строка из 1 буквы
            ex[st_ch-'a'] = true;
            m[st_ch] = inf;
        }
        else{
            //Тогда не из одной
            //cerr<<j<<" for "<<st_ch<<endl;
            m[st_ch]+=j;
        }
    }
    bool res = true;
    for(int i = 0;i<e;i++){
        if(ex[i] == false){
            res = false;
            break;
        }
    }
    if(res == true){
        //Тогда все есть
        cout<<"NO"<<endl;
        return ;
    }
    else{
        vector<pair<int,char>> ress;
        for(int i = 0;i<e;i++){
            ress.push_back(make_pair(m[alpahbet[i]], alpahbet[i]));
        }
        sort(ress.begin(), ress.end());
        if(ress[0].first >= inf){
            cout<<"NO"<<endl;
            return ;
        }
        else{
            string sss;
            for(int _ = 0;_<ress[0].first;_++){
                sss+=ress[0].second;
            }
            cout<<sss<<endl;
        }

    }
}


signed main() {

    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
    cin >> test;
    while (test--) {
        solve_j();
    }

    return 0;
}
