﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Threading;
using System.Diagnostics;
using System.Numerics;
using System.IO;
using System.Reflection;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Runtime.CompilerServices;
using System.Globalization;
using System.Drawing;

namespace icpc
{
    class Program
    {
        static void Main(string[] args)
        {
            int t = int.Parse(Console.ReadLine());
            for (int i = 0; i < t; i++)
            {
                Test();
            }
        }

        private static void Test()
        {
            int n = int.Parse(Console.ReadLine());
            int[] h = Array.ConvertAll(Console.ReadLine().Split(), int.Parse);
            int[] p = Array.ConvertAll(Console.ReadLine().Split(), int.Parse);
            List<Mountain> ps = h.Zip(p, (x, y) => (x, y)).Select(t => new Mountain(t.Item2, t.Item1)).OrderBy(x => x.New).ThenBy(x => x.Old).ToList();
            if (ps.Any(x => x.Delta < 0))
            {
                Console.WriteLine(-1);
                return;
            }
            int dm = ps[0].Delta;
            for (int i = 1; i < ps.Count; i++)
            {
                if (ps[i].Delta < dm || ps[i - 1].Old > ps[i].Old)
                {
                    Console.WriteLine(-1);
                    return;
                }
                dm = ps[i].Delta;
            }
            Console.WriteLine(ps[ps.Count - 1].Delta);
        }

        private struct Mountain
        {
            public readonly int Old;
            public readonly int New;
            public int Delta { get { return Old - New; } }

            public Mountain(int o, int n)
            {
                Old = o;
                New = n;
            }

            public override string ToString()
            {
                return $"{Old} -> {New}";
            }
        }
    }
}
