﻿#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma comment(linker, "/STACK:67108864")

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <random>
#include <string>

#define int long long

using namespace std;

#ifdef TREAP

mt19937 mt;

int BIGrand() {
    return ((mt() >> 1) << 32) | mt();
}

struct Nd {
    int x;
    int y;
    Nd* l;
    Nd* r;
    Nd* p;
    int size;
    Nd(int x) : x(x), y(BIGrand()) {}
    Nd() : x(0), y(BIGrand()) {}
};

int gsize(Nd* t) {
    return t ? t->size : 0;
}
void upd(Nd* t) {
    if (t) {
        t->size = gsize(t->l) + gsize(t->r) + 1;
    }
}
void push(Nd* t) {
}
Nd* merge(Nd* l, Nd* r) {
    if (!l || !r) {
        return l ? l : r;
    }
    push(l);
    push(r);
    if (l->y > r->y) {
        l->r = merge(l->r, r);
        upd(l);
        return l;
    }
    else {
        r->l = merge(l, r->l);
        upd(r);
        return r;
    }
}
void split(Nd* t, int k, Nd*& l, Nd*& r) {
    if (!t) {
        l = r = t;
        return;
    }
    push(t);
    if (gsize(t->l) >= k) {
        r = t;
        split(t->l, k, l, r->l);
    }
    else {
        l = t;
        split(t->r, k - gsize(t->l) - 1, l->r, r);
    }
    upd(l);
    upd(r);
}
void split_l(Nd* t, int x, Nd*& l, Nd*& r) {
    if (!t) {
        l = r = t;
        return;
    }
    push(t);
    if (t->x > x) {
        r = t;
        split_l(t->l, x, l, r->l);
    }
    else {
        l = t;
        split_l(t->r, x, l->r, r);
    }
    upd(l);
    upd(r);
}
void split_r(Nd* t, int x, Nd*& l, Nd*& r) {
    if (!t) {
        l = r = t;
        return;
    }
    push(t);
    if (t->x >= x) {
        r = t;
        split_r(t->l, x, l, r->l);
    }
    else {
        l = t;
        split_r(t->r, x, l->r, r);
    }
    upd(l);
    upd(r);
}

Nd* find(Nd* t, int x) {
    if (!t || t->x == x) {
        return t;
    }
    if (t->x < x) {
        return find(t->r, x);
    }
    return find(t->l, x);
}

void ins(Nd*& t, int x) {
    if (!find(t, x)) {
        Nd* v = new Nd(x);
        Nd* fi;
        Nd* se;
        split_r(t, x, fi, se);
        t = merge(merge(fi, v), se);
    }
}

void del(Nd*& t, int x) {
    if (find(t, x)) {
        Nd* fi;
        Nd* se;
        Nd* th;
        split_r(t, x, fi, se);
        split_l(se, x, se, th);
        delete se;
        t = merge(fi, th);
    }
}
int getnum(Nd*& t, int x) {
    Nd* fi;
    Nd* se;
    split_l(t, x, fi, se);
    int res = gsize(fi);
    t = merge(fi, se);
    return res;
}

#endif // 

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> da(n);
    for (int i = 0; i < n; ++i) {
        cin >> da[i].second;
    }
    for (int i = 0; i < n; ++i) {
        cin >> da[i].first;
    }
    sort(da.begin(), da.end());

    int prevdiff = 0;
    int prevfirst = -1;
    int prevsecond = -1;
    for (int i = 0; i < n; ++i) {
        int diff = da[i].first - da[i].second;
        if (diff < prevdiff) {
            cout << -1 << endl;
            return;
        } else {
            if (da[i].first == prevfirst) {
                if (da[i].second != da[i - 1].second) {
                    cout << -1 << endl;
                    return;
                }
            }
            if (prevsecond > da[i].second) {
                cout << -1 << endl;
                return;
            }
            prevsecond = da[i].second;
            prevfirst = da[i].first;
            prevdiff = diff;
        }
    }
    cout << prevdiff << endl;
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}